'use strict';

var debug = require('debug');

var debugFunc = void 0;
var phase = 'default';
var namespace = '';
var newDebug = function newDebug() {
	debugFunc = namespace ? debug('fetch-mock:' + phase + ':' + namespace) : debug('fetch-mock:' + phase);
};

var newDebugSandbox = function newDebugSandbox(ns) {
	return debug('fetch-mock:' + phase + ':' + ns);
};

newDebug();

module.exports = {
	debug: function debug() {
		debugFunc.apply(undefined, arguments);
	},
	setDebugNamespace: function setDebugNamespace(str) {
		namespace = str;
		newDebug();
	},
	setDebugPhase: function setDebugPhase(str) {
		phase = str || 'default';
		newDebug();
	},
	getDebug: function getDebug(namespace) {
		return newDebugSandbox(namespace);
	}
};